package pre3166;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;
	
@SuppressWarnings({ "serial", "unused" })
public class Server extends JFrame {
	
	private JButton send_btn;
    private JButton listen_btn;
    private JButton discon_btn;
    private JCheckBox cr_check;
    private JCheckBox lf_check;
    private JLabel jLabel1;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JLabel jLabel4;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JTextField send_text;
    private JTextField port_text;
    private JTextArea status;
    private JTextArea data;
    private Socket sock;
    private ServerSocket server;
	private BufferedReader br = null;
	private PrintWriter pw = null;	

	
    public Server() {
    	super("TCP Server ~ ITCS-3166");
        initComponents();
    }

    private void initComponents() {
    	
    	// Make the GUI 
        send_text = new JTextField();
        send_btn = new JButton();
        jLabel1 = new JLabel();
                
        cr_check = new JCheckBox();
        lf_check = new JCheckBox();
        jLabel2 = new JLabel();
        jLabel3 = new JLabel();
        jLabel4 = new JLabel();
        port_text = new JTextField();
        listen_btn = new JButton();
        discon_btn = new JButton();
        jLabel5 = new JLabel();
        jLabel6 = new JLabel();
        status = new JTextArea();
        data = new JTextArea();
        jScrollPane1 = new JScrollPane(data);
        jScrollPane2 = new JScrollPane(status);
        
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        
        status.setLineWrap(true);
        jScrollPane1.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        data.setLineWrap(true);
        jScrollPane2.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    
        send_btn.setFont(new Font("Verdana", 0, 11));
        send_btn.setText("SEND");
        // send button click event
        send_btn.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
            	send_btnMouseClicked(evt);
            }
        });

        jLabel1.setFont(new Font("Verdana", 0, 12));
        jLabel1.setText("SEND");

        cr_check.setText("cr_check");
        lf_check.setText("lf_check");

        jLabel2.setFont(new Font("Verdana", 0, 12));
        

        jLabel3.setFont(new Font("Verdana", 0, 12));
       

        jLabel4.setFont(new Font("Verdana", 0, 12));
        jLabel4.setText("TCP PORT");

        port_text.setText("1810");

        listen_btn.setFont(new Font("Verdana", 0, 11)); // NOI18N
        listen_btn.setText("LISTEN");
        // listen button click event
        listen_btn.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
            	listen_btnMouseClicked(evt);
            }
        });
        
        discon_btn.setFont(new Font("Verdana", 0, 11)); // NOI18N
        discon_btn.setText("DISCONNECT");

        jLabel5.setFont(new Font("Verdana", 0, 12));
       

        jLabel6.setFont(new Font("Verdana", 0, 12)); // NOI18N
        jLabel6.setText("Status");

        // button disabled except listen button. 
        discon_btn.setEnabled(false); 
        discon_btn.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
            	try {
					discon_btnMouseClicked(evt);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            }
        });
        
        send_btn.setEnabled(false);
        
        // Make the dialog layout 
        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 490, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, GroupLayout.DEFAULT_SIZE, 490, Short.MAX_VALUE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1, GroupLayout.PREFERRED_SIZE, 65, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 332, Short.MAX_VALUE)
                        .addComponent(cr_check, GroupLayout.PREFERRED_SIZE, 21, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2)
                        .addGap(18, 18, 18)
                        .addComponent(lf_check, GroupLayout.PREFERRED_SIZE, 21, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(send_text, GroupLayout.DEFAULT_SIZE, 413, Short.MAX_VALUE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(send_btn))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
                            .addComponent(port_text)
                            .addComponent(jLabel4, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 198, Short.MAX_VALUE)
                        .addComponent(listen_btn, GroupLayout.PREFERRED_SIZE, 112, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(discon_btn)))
                .addContainerGap())
        );

        layout.linkSize(SwingConstants.HORIZONTAL, new Component[] {listen_btn, discon_btn});

        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel6)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, GroupLayout.PREFERRED_SIZE, 41, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, 168, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(lf_check)
                    .addComponent(jLabel3)
                    .addComponent(cr_check)
                    .addComponent(jLabel2))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(send_text, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4))
                    .addComponent(send_btn))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(port_text, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(discon_btn)
                    .addComponent(listen_btn, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }
                                     
    /* DESCRIPTION
     *	listen button event method,
	 *	1. Make a socket and receive buffer
	 *  2. Receiving the packet thread start
     * ARGUMENTS
     *	port - Local Port variable, integer
     *  wit - thread variable
     */
    protected void listen_btnMouseClicked(MouseEvent evt) {
    	
		int port = Integer.parseInt(port_text.getText());
		
		try {
			server = new ServerSocket(port);
			
			System.out.println("Listen...");
			status.append(" Listen...");
			status.append("\n");
	        jScrollPane2.getVerticalScrollBar().setValue(jScrollPane2.getVerticalScrollBar().getMaximum());
	        
			WinOutputThread wit = new WinOutputThread();
			wit.start();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
	}
    
	/* DESCRIPTION
	 *	Convert String to Hex method
	 * ARGUMENTS
	 *	hex - hexadigit string
	 *	str - ascii string  
	 * RETURN VALUE
	 *  returns result of the conversion
	 */	
    public String StringtoHex(String str)
    {
    	String hex = "";
    	for(int i=0; i<str.length(); i++)
    	{   
    		System.out.println(Integer.toHexString((int)str.charAt(i)));
    		if(Integer.toHexString((int)str.charAt(i)).length() < 2)
        		hex = hex + "0" + Integer.toHexString((int)str.charAt(i)) + " ";
    		else
    			hex = hex + Integer.toHexString((int)str.charAt(i)) + " ";
    	}
    	
		return hex;	
    
    }
    
    /* DESCRIPTION
     *	Send button event method,
     *  Send the data to socket 
     * ARGUMENTS
     *	sendstr - send data, String
     *  hexstr -  send data converted to hex, String 
     *  dlg - Warning dialog, Dialog
     *  msg - Warning message, Label
     *  ok - confirm button on the warning dialog 
     *  pw - output stream
     */
    protected void send_btnMouseClicked(MouseEvent evt) {
    	
		String sendstr = "";
		String hexstr = "";

		// if the user click the send button when the socket is close, it shows warning dialog
		if(sock == null){
			
        	final Dialog dlg = new Dialog(this, "Warning!");
        	dlg.setSize(300,100);
        	Label msg = new Label("Connect the socket, first.", Label.CENTER);
        	Button ok = new Button("OK");
        	
        	dlg.setLayout(new FlowLayout());
        	dlg.add(msg);
        	dlg.add(ok);
        	
        	ok.addMouseListener(new MouseAdapter(){
        		public void mouseClicked(MouseEvent e){
        			dlg.dispose();
        		}
        	});
        	
        	dlg.setVisible(true);
        	
		}
		// send the data to socket 
		else{
			
			sendstr = send_text.getText();
			
			if(sendstr.equals("") && cr_check.isSelected() == false && lf_check.isSelected() == false )
			{
				
	        	final Dialog dlg = new Dialog(this, "Warning!");
	        	dlg.setSize(300,100);
	        	Label msg = new Label("Insert the message", Label.CENTER);
	        	Button ok = new Button("OK");
	        	
	            dlg.setLayout(new FlowLayout());
	            dlg.add(msg);
	            dlg.add(ok);
	            
	        	ok.addMouseListener(new MouseAdapter(){
	        		public void mouseClicked(MouseEvent e){
	        			dlg.dispose();
	        		}
	        	});
	        	
	        	dlg.setVisible(true);	          
			}
			
			else{

				pw.print(sendstr);
				
				if(cr_check.isSelected())
				{
					pw.print("\r");
					sendstr = sendstr + "\r";
				}
				if(lf_check.isSelected())
				{
					pw.print("\n");
					sendstr = sendstr + "\n";
				}
				pw.flush();
				
				hexstr = StringtoHex(sendstr);
				data.append("Send data : ");			
				data.append(hexstr+" | ");
				data.append(sendstr);
				data.append("\n");
						
				send_text.setText("");
			}
		}
	}
    
    /* DESCRIPTION
     *	disconnect button event method,
     *  disconnect the socket connection 
     * ARGUMENTS
     *	sendstr - send data, String
     *  hexstr -  send data converted to hex, String 
     *  dlg - Warning dialog, Dialog
     *  msg - Warning message, Label
     *  ok - confirm button on the warning dialog 
     *  pw - output stream
     *  br - input stream
     *  sock - socket 
	 *  connect_btn - connect button object
	 *  send_btn - send button object
	 *  disconn_btn - disconnect button object 
	 */
    protected void discon_btnMouseClicked(MouseEvent evt) throws IOException
    {
    	
		server.close();
		sock.close();
		
		status.append("Socket Closed \n");
        jScrollPane2.getVerticalScrollBar().setValue(jScrollPane2.getVerticalScrollBar().getMaximum());
        
		discon_btn.setEnabled(false);
		send_btn.setEnabled(false);
		listen_btn.setEnabled(true);

    }

    /* DESCRIPTION
     *	main method
	 */
	public static void main(String args[]) {
        Server TCPServer = new Server();
        TCPServer.setVisible(true);
    }

	/* DESCRIPTION
	 *	Thread for socket making  
	 */	 
	class WinOutputThread extends Thread{
		
		/* DESCRIPTION
		 *	run the thread method
		 *  1. make the server socket 
		 *  2. call the Input Thread
		 * ARGUMENTS
		 *  pw - output stream buffer
	     *  sock - socket 
	     *  InetAddress - ip variable
		 *  connect_btn - connect button object
		 *  send_btn - send button object
		 *  disconn_btn - disconnect button object  
		 */	
		public void run(){
			
			try {
				sock = server.accept();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			send_btn.setEnabled(true);
			discon_btn.setEnabled(true);
			listen_btn.setEnabled(false);
			
			InetAddress inetaddr = sock.getInetAddress();
			status.append("Connected ("+inetaddr.getHostAddress()+")");
			status.append("\n");
			System.out.println("Connected ("+inetaddr.getHostAddress()+")");
	        jScrollPane2.getVerticalScrollBar().setValue(jScrollPane2.getVerticalScrollBar().getMaximum());
	        
			WinInputThread win = new WinInputThread(sock);
			win.start();
			
			try {
				pw = new PrintWriter(new OutputStreamWriter(sock.getOutputStream()));
			} catch (IOException e) {
			
				e.printStackTrace();
			}
			
		}
		
	}
	
	/* DESCRIPTION
	 *	Thread for packet receiving 
	 */	
	class WinInputThread extends Thread{

		public WinInputThread(Socket sock){
			
			try {
				br = new BufferedReader(new InputStreamReader(sock.getInputStream()));
			} catch (IOException e) {		
				e.printStackTrace();		
			}
			
		}
		
		/* DESCRIPTION
		 *	Convert character to Hex method
		 * ARGUMENTS
		 *	hexstr - hexadigit string
		 *	buf - ascii data array  
		 * RETURN VALUE
		 *  returns result of the conversion
		 */	
		public String charTohex(char[] buf)
		{

			String hexstr = "";
			for(int i=0; i<buf.length; i++){
				if( (int)buf[i] != 0 )
				{
					
		    		if(Integer.toHexString((int)buf[i]).length() < 2)
		    			hexstr = hexstr + "0" + Integer.toHexString((int)buf[i]) + " ";
		    		else
		    			hexstr = hexstr + Integer.toHexString((int)buf[i]) + " ";
				}
			}
			return hexstr;
		}
		
		/* DESCRIPTION
		 *	run the thread method
		 * ARGUMENTS
		 *  buf - ascii data array 
		 *  hexstr - hexadigit string
		 *  read - read buffer monitoring value, int
	     *  sock - socket 
		 *  connect_btn - connect button object
		 *  send_btn - send button object
		 *  disconn_btn - disconnect button object  
		 */			
		public void run()
		{
			
			try
			{
				
				char[] buf = new char[4096];
				String hexstr = "";	
				
				int read = 0;
				
				// wait the receiving packet until socket close 
				while((read = br.read(buf)) != 0)
				{
					if(read != -1)
					{
			
						System.out.println("insert to try \n");
						data.append("Receive data : ");
	
						// convert Decimal to HEX 
						hexstr = charTohex(buf);
									
						data.append(hexstr+" | ");
						data.append(new String(buf,0,read));
						data.append("\n");
					}
					else
					{
						break;

					}
					
				}
				server.close();
				sock.close();
				
				status.append("Socket Closed. \n");
		        jScrollPane2.getVerticalScrollBar().setValue(jScrollPane2.getVerticalScrollBar().getMaximum());
		        
				discon_btn.setEnabled(false);
				send_btn.setEnabled(false);
				listen_btn.setEnabled(true);
			
			}catch(Exception e){
				try {
					// if a problem occurs in socket, It'll close the socket. 
					e.printStackTrace();
					System.out.println("insert to catch \n");
					server.close();
					sock.close();
					
					status.append("Socket Closed. \n");
			        jScrollPane2.getVerticalScrollBar().setValue(jScrollPane2.getVerticalScrollBar().getMaximum());
			        
					discon_btn.setEnabled(false);
					send_btn.setEnabled(false);
					listen_btn.setEnabled(true);
					
				} catch (IOException e1) {

					e1.printStackTrace();
				}
				
				
			}finally{
				try{
					if(br != null)
						br.close();
					
				}catch(Exception ex){}

			}
			

		}
	}
	
    // Variables declaration 
    
}




